Subject: Re: [lojban] Lojban for lay programmers

From: Candide Kemmler <[email-masked]>
Date: Thu, 24 Jan 2002 09:40:35 +0100

Hi Robert,

Great ! I have exactly the same feeling about lojban as you. And 
specifically about using lojban as a means for humans to deal more 
comfortably with the world of technology.

Beginning with my interest for lojban, I immediately suggested a few 
things to develop, like voice synthesis/recognition, develop a lojban 
programming language, and explore ways to combine lojban with the 
semantic web.

I am happy that, as of the voice synthesis project, with the help of 
Jack Crosscope, I have now recorded a whole set of good quality diphones 
(1186 !), which will allow to build at least one natural-sounding voice 
for lojban. This is I think a good point for the learning masses who'll 
be happy to cost-effectively train with hearing and effectively 
recognizing the language.

Now, concerning developing a programming language, I am currently using 
a fantastic tool called antlr (http://www.antlr.org/) to help me write a 
source-to-source translator from java to objective-c. One could begin 
with rewriting the lojban grammar/lexer rules in this tool's formalism, 
which shouldn't be too hard since a Yacc grammar already exists. The 
resulting parser would be a very good starting point for writing a 
lojban interpreter in a fairly easy way, using java; we could later move 
to c++, since antlr is also able to generate c++ parsers from the same 
specifications, or to objective-c, when my translator is finally 
working ;-)

Hence, I AM VOLUNTEERING TO WRITE AN ANTLR GRAMMAR FOR LOJBAN*

*writing this in capital letters for the rapid readers, but I think I 
will post another message for this project one of these days.

It was great reading your message. I think lojban is indeed much more 
than a language hobbyist's toy. The very motivation for its inception 
(or that of its direct ancestor) indeed was part of a humanist vision 
and I think we should try to continuate this tradition.

Candide

Le mercredi 23 janvier 2002, à 11:32 PM, Robert J. Chassell a écrit :

> Next week I am going to a workshop sponsored by the Institute for
> Scientific Interchange, Turin, Italy,
>
> http://www.isi.it/summary.html
>
> regarding a:
>
> ... package--let's call it the "Knowledge Home"--aimed at giving
> individuals more independence and power in a world increasingly
> dependent on computers.
>
> http://kh.bu.edu/
>
> I am going to suggest Lojban as a possible tool....
>
> The thesis behind the workshop is that everyone has a `home' of some
> sort, which consists of some culturally defined characteristics, like
> a kitchen and bedroom, and some personally defined characteristics.
>
> The same should apply to computers and software. The metaphorical
> name for this is a `Knowledge Home'. One of the requirements is that
> it be easy to `move the furniture' in one's `Knowledge Home'.
>
> (It is also necessary that one have the legal freedom to move one's
> furniture. I have three different ways to contribute to this
> workshop: software freedom, Emacs Lisp (about which I have just
> completed the second edition of an introduction), and Lojban, which my
> sponsor did not know I knew about (and may himself not care for). I
> was invited to this workshop on account of my knowledge of software
> freedom and Emacs Lisp.)
>
>
> Another way to present the thesis behind the workshop is that humans,
> in the Paleolithic and more recently, worked in an
>
> edit/fabricate/evaluate
>
> cycle. (People do not do this in a world of mass production.)
>
> That is to say, a person first figures out what to create, using
> culturally available templates, such as `bed' or `love letter', then
> makes the object, and then judges how well or beautifully the created
> entity fulfills its intention.
>
> In the old days, the `fabricate' part of the cycle was difficult and
> time consuming. Consider how long it took to typeset a book when the
> job was done by hand.
>
> Now, for some things that computers can do, the `fabricate' part is
> quick and easy. For example, I can now run a program to typeset a 250
> page book in 2 1/2 seconds. Nowadays, the editing and evaluation
> parts of the cycle. are hard and expensive for me.
>
>
> I think of Lojban as potentially more sophisticated for a `scripting'
> or `verbing' language for the the `Knowledge Home' project than Emacs
> Lisp or Python. Those are two programming languages that have been
> mentioned so far as possible `scripting' or `verbing' languages for
> educated, non-programmers for this project.
>
> I think the idea behind the workshop is that the non-programmers would
> learn to use the language just as ordinary people learn to read
> musical notation for singing in a church choir. Although I wrote my
> `Introduction to Programming in Emacs Lisp' for non-programmers, it
> does take a certain mind-set or desire to work with the language.
>
> I am going to point out that Lojban is (1) able to express everything
> a natural language does, (2) able to be used (with a subset of the
> vocabulary, but the same grammar) as a computer scripting language,
> and (3) able to be recognized by a speech-to-text engine more readily
> than a natural language, since it is designed to be simple and
> coherent. (People would converse with their computers -- a goal
> with which I agree.)
>
> So, in theory, if you learn to speak Lojban fluently, you should have
> no trouble programming with it .... :-) Of course, you _do_ have to
> learn Lojban, which I have not done yet.
>
> Put another way: the choice is between learning a programming
> language such as Emacs Lisp, or learning a full language.....
>
> This may be the down-side of the Lojban idea, since it is much harder
> to learn a full language than a programming language. On the other
> hand, if you do learn Lojban, you get a full language out of it, with
> all that that entails, as well as, hypothetically, a programming
> language.
>
> I am also going to say that so far, the only programming language
> subset of Lojban that I know about Nick Nicholas' Prolog Parser, from
> 1993. A great deal of work will be required to turn Lojban into a
> programming language as well as a spoken language. So I'll call
> Lojban a `prototype' for this `Knowledge Home' project.
>
> Nonetheless, I think that Lojban may be the best tool for the project,
> at least for the initial phases, assuming the project gets more
> funding and goes somewhere.
>
> Needless to say, all this happens to me after several years during
> which I have been too busy to pay attention to Lojban. So I have a
> hard time remembering anything about Lojban. But I will try.
>
> --
> Robert J. Chassell [email-masked]
> Rattlesnake Enterprises http://www.rattlesnake.com
>
> To unsubscribe, send mail to [email-masked]
>
> Your use of Yahoo! Groups is subject to 
> http://docs.yahoo.com/info/terms/
>
>